#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------
## Daniel Wollschlger <dwoll [at] psychologie.uni-kiel.de>
## ergnzende Befehle zum Buch "Grundlagen der Datenanalyse mit R" (Springer)
## http://www.uni-kiel.de/psychologie/dwoll/r/
## Stand: 07.04.11
##
## Vgl. Abschnitt 4.1, um die folgenden Befehle auszufhren.
##
## Um alle Teile des Skripts ausfhren zu knnen, muss das Paket
## boot samt Abhngigkeiten installiert sein, vgl. Abschnitt 1.2.7:
##
## install.packages("boot", repos="http://ftp5.gwdg.de/pub/misc/cran/")
##
## Befehle, die das Ausfhren weiterer Befehle verhindern, sind auskommentiert.
#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------

##### 12.3 Funktionen analysieren
##### 12.3.1
sd
base::mean
boot:::basic.ci

get("fligner.test")
methods("fligner.test")
## get("fligner.test.default")
getS3method("fligner.test", "default")

##### 12.3.2
myPlot <- function(x, y, xLims=xRange) {
    stopifnot(is.numeric(x), is.numeric(y))
    stopifnot(length(x) > 0, length(y) > 0)
    if(length(x) != length(y)) {
        warning("x und y haben ungleiche Lnge -> krze")
        lenMin <- min(length(x), length(y))
        x <- x[1:lenMin]
        y <- y[1:lenMin]
    }

    xRange <- round(range(x), -1) + c(-10, 10)
    plot(x, y, xlim=xLims)
}

myPlot(1:5, 1:10)
## myPlot(1:2, "ABC")
## traceback()

info         <- function(x) { UseMethod("info") }
info.numeric <- function(x) { range(x)  }
info.default <- function(x) { length(x) }

debug(info)
## info(sample(1:10, 10, replace=TRUE))
undebug(info)

##### 12.3.3
system.time(solve(matrix(sample(1:100, 200^2, replace=TRUE), nrow=200)))
xDbl <- rnorm(10000, 0, 10)
object.size(xDbl)
object.size(as.integer(xDbl))
