#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------
## Daniel Wollschlger <dwoll [at] psychologie.uni-kiel.de>
## ergnzende Befehle zum Buch "Grundlagen der Datenanalyse mit R" (Springer)
## http://www.uni-kiel.de/psychologie/dwoll/r/
## Stand: 10.03.11
##
## Vgl. Abschnitt 4.1, um die folgenden Befehle auszufhren.
#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------

##### 6.7 Partialkorrelation und Semipartialkorrelation
## Daten erstellen wie in 6.3
N      <- 100
height <- rnorm(N, 175, 7)
age    <- rnorm(N,  30, 8)
sport  <- abs(rnorm(N, 60, 30))
weight <- 0.5*height - 0.3*age - 0.4*sport + 10 + rnorm(N, 0, 3)
## fr Daten des Abschnitts diese Datei laden:
# load("data_multRegrN.Rdata")

weight.S <- residuals(lm(weight ~ sport))
height.S <- residuals(lm(height ~ sport))
cor(weight.S, height.S)
(cor(weight, height) - (cor(weight, sport) * cor(height, sport))) /
     sqrt((1-cor(weight, sport)^2) * (1-cor(height, sport)^2))

R        <- cor(cbind(weight, height, sport))
Rinv     <- solve(R)
DsqrtInv <- diag(1/sqrt(diag(Rinv)))
Rpart    <- -(DsqrtInv %*% Rinv %*% DsqrtInv)
Rpart[upper.tri(Rpart)]

Dinv  <- diag(1/diag(Rinv))
Betas <- -(Dinv %*% Rinv)
Betas[upper.tri(Betas)]
fit   <- lm(scale(weight) ~ scale(height) + scale(sport))
zapsmall(coefficients(fit))

cor(weight, height.S)
(cor(weight, height) - (cor(weight, sport) * cor(height, sport))) /
     sqrt(1-cor(height, sport)^2)

weight.AS   <- residuals(lm(weight ~ age + sport))
height.AS   <- residuals(lm(height ~ age + sport))
(pcorWH.AS  <- cor(weight.AS, height.AS))
(spcorWH.AS <- cor(weight, height.AS))

spcorWH.AS^2
fitAS  <- lm(weight ~          age + sport)
fitHAS <- lm(weight ~ height + age + sport)
summary(fitHAS)$r.squared - summary(fitAS)$r.squared

fitHAS
cov(weight, height.AS) / var(height.AS)
