#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------
## Daniel Wollschlger <dwoll [at] psychologie.uni-kiel.de>
## ergnzende Befehle zum Buch "Grundlagen der Datenanalyse mit R" (Springer)
## http://www.uni-kiel.de/psychologie/dwoll/r/
## Stand: 19.05.11
##
## Vgl. Abschnitt 4.1, um die folgenden Befehle auszufhren.
##
## Um alle Teile des Skripts ausfhren zu knnen, muss das Paket
## ICSNP samt Abhngigkeiten installiert sein, vgl. Abschnitt 1.2.7:
##
## install.packages("ICSNP", repos="http://ftp5.gwdg.de/pub/misc/cran/")
#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------

##### 10.6.3 Hotellings T^2 fr zwei abhngige Stichproben
N    <- 20
P    <- 2
Y1t0 <- rnorm(N, mean=90,  sd=15)
Y1t1 <- rnorm(N, mean=100, sd=15)
Y2t0 <- rnorm(N, mean=85,  sd=15)
Y2t1 <- rnorm(N, mean=105, sd=15)
IV   <- factor(rep(1:P, each=N), labels=c("t0", "t1"))
id   <- factor(rep(1:N, times=P))
Ydf  <- data.frame(id, Y1=c(Y1t0, Y1t1), Y2=c(Y2t0, Y2t1), IV)
## fr Daten des Buches diese Datei laden:
# load("data_tSq2dep.Rdata")

dfDiff <- aggregate(cbind(Y1, Y2) ~ id, data=Ydf, FUN=diff)
DVdiff <- data.matrix(dfDiff[ , c("Y1", "Y2")])
muH0   <- c(0, 0)

library(ICSNP)
HotellingsT2(DVdiff, mu=muH0)

anova(lm(DVdiff ~ 1), test="Hotelling-Lawley")

## entferne die (ggf. automatisch) geladenen Zusatzpakete, sofern mglich
try({
detach(package:ICSNP)
detach(package:ICS)
detach(package:survey)
detach(package:mvtnorm) })
